#
# need to init arrays/lists with style/color options that 
# supply class defaults matching tkxg defaults.
catch {destroy .tkxg}
catch {destroy .tkxg.c}
toplevel .tkxg
wm protocol .tkxg WM_DELETE_WINDOW Tkxg_Destroy_and_exit
wm withdraw .
wm withdraw .tkxg
canvas .tkxg.c
pack append .tkxg .tkxg.c {top frame center expand fill}
wm geometry .tkxg 600x600+10+10

global __tkxg __tkxgrender
catch {unset __tkxg}
catch {unset __tkxgrender}
set __tkxg(namelist) 0
set __tkxg(autoredraw) 0
set __tkxgrender(linecolor) ""
set __tkxgrender(linewidth) ""
set __tkxgrender(linestipple) ""

menu .tkxg.mbar \
  -tearoff 0

#
# queries for a file name or printer destination and writes ps
#
proc Tkxg_Print {} {
  error "not implemented"
}

#asks for input file names, expands the menus to include a
# new graph buffer,
# calls tkxg -f filename
#
proc Tkxg_NewPlot {} {
  error "not implemented"
}

proc Tkxg_ChangeCanvas {g} {
  error "not implemented"
}

proc Tkxg_traceopts {a s e} {
  global __tkxg
  if {$__tkxg(autoredraw)} {
    catch {Tkxg_PlotCurrent}
  }
}

proc Tkxg_Titlefont {} {
  global __tkxg_opt
  set font [ascFontGet]
  set __tkxg_opt(-titlefont) $font
}

proc Tkxg_Labelfont {} {
  global __tkxg_opt
  set font [ascFontGet]
  set __tkxg_opt(-labelfont) $font
}

proc Tkxg_PlotCurrent {} {
  global __tkxg_current __tkxg_opt
  .tkxg.c delete all
  catch {$__tkxg_current configure -barbase $__tkxg_opt(-barbase)}
  catch {$__tkxg_current configure -bargraph $__tkxg_opt(-bargraph)}
  catch {$__tkxg_current configure -barwidth $__tkxg_opt(-barwidth)}
  catch {$__tkxg_current configure -bordercolor $__tkxg_opt(-bordercolor)}
  catch {$__tkxg_current configure -borderwidth $__tkxg_opt(-borderwidth)}
  catch {$__tkxg_current configure -boundingbox $__tkxg_opt(-boundingbox)}
  catch {$__tkxg_current configure -gridwidth $__tkxg_opt(-gridwidth)}
  catch {$__tkxg_current configure -gridstipple $__tkxg_opt(-gridstipple)}
  catch {$__tkxg_current configure -height $__tkxg_opt(-height)}
  catch {$__tkxg_current configure -labelfont $__tkxg_opt(-labelfont)}
  catch {$__tkxg_current configure -logx $__tkxg_opt(-logx)}
  catch {$__tkxg_current configure -logy $__tkxg_opt(-logy)}
  catch {$__tkxg_current configure -mm $__tkxg_opt(-mm)}
  catch {$__tkxg_current configure -mM $__tkxg_opt(-mM)}
  catch {$__tkxg_current configure -mp $__tkxg_opt(-mp)}
  catch {$__tkxg_current configure -mP $__tkxg_opt(-mP)}
  catch {$__tkxg_current configure -negatex $__tkxg_opt(-negatex)}
  catch {$__tkxg_current configure -negatey $__tkxg_opt(-negatey)}
  catch {$__tkxg_current configure -nolines $__tkxg_opt(-nolines)}
  catch {$__tkxg_current configure -ticks $__tkxg_opt(-ticks)}
  catch {$__tkxg_current configure -title $__tkxg_opt(-title)}
  catch {$__tkxg_current configure -titlefont $__tkxg_opt(-titlefont)}
  catch {$__tkxg_current configure -width $__tkxg_opt(-width)}
  catch {$__tkxg_current configure -xhigh $__tkxg_opt(-xhigh)}
  catch {$__tkxg_current configure -xlow $__tkxg_opt(-xlow)}
  catch {$__tkxg_current configure -xtitle $__tkxg_opt(-xtitle)}
  catch {$__tkxg_current configure -yhigh $__tkxg_opt(-yhigh)}
  catch {$__tkxg_current configure -ylow $__tkxg_opt(-ylow)}
  catch {$__tkxg_current configure -ytitle $__tkxg_opt(-ytitle)}
  catch {$__tkxg_current configure -zerocolor $__tkxg_opt(-zerocolor)}
  for {set i 0} {$i <[$__tkxg_current maxsets]} {incr i} {
      catch {$__tkxg_current configure -serieslegend $i \
                             $__tkxg_opt(-serieslegend$i)}
      catch {$__tkxg_current configure -seriescolor $i \
                             $__tkxg_opt(-seriescolor$i)}
      catch {$__tkxg_current configure -serieswidth $i \
                             $__tkxg_opt(-serieswidth$i)}
      catch {$__tkxg_current configure -seriesmarker $i \
                             $__tkxg_opt(-seriesmarker$i)}
      catch {$__tkxg_current configure -seriesstipple $i \
                             $__tkxg_opt(-seriesstipple$i)}
    }
  $__tkxg_current plot
}

proc Tkxg_build_filemenu {} {
  catch {destroy .tkxg.mbar.file}
  menu .tkxg.mbar.file \
    -tearoff 0
  .tkxg.mbar.file add command \
    -label "New data ..." \
    -state disabled \
  -command Tkxg_NewPlot
  .tkxg.mbar.file add command \
    -label "Print ..." \
    -state disabled \
    -command Tkxg_Print
  .tkxg.mbar.file add command \
    -label "Save Postscript ..." \
    -command Tkxg_PSWrite
  .tkxg.mbar.file add command \
    -label Exit \
    -command Tkxg_Destroy_and_exit
  .tkxg.mbar.file add separator
  .tkxg.mbar.file add command \
    -label xgraph0 \
    -command "Tkxg_ChangeCanvas xgraph0"
  
}

Tkxg_build_filemenu

  menu .tkxg.mbar.exec \
    -tearoff 0
  menu .tkxg.mbar.opts \
    -tearoff 0

.tkxg.mbar add cascade \
  -label File \
  -menu .tkxg.mbar.file
.tkxg.mbar add cascade \
  -label Execute \
  -menu .tkxg.mbar.exec
.tkxg.mbar add cascade \
  -label Options \
  -menu .tkxg.mbar.opts

.tkxg.mbar.exec add command \
  -label Redraw \
  -command Tkxg_PlotCurrent
.tkxg.mbar.exec add checkbutton \
  -label "Automatically redraw" \
  -variable __tkxg(autoredraw) \
  -onvalue 1 \
  -offvalue 0

.tkxg.mbar.opts add command \
  -label Reconfigure \
  -command Tkxg_Reconfigure
.tkxg.mbar.opts add command \
  -label "Title font" \
  -command Tkxg_Titlefont
.tkxg.mbar.opts add command \
  -label "Label font" \
  -command Tkxg_Labelfont

#do this part last
.tkxg configure -menu .tkxg.mbar


proc Tkxg_PSWrite {} {
  set filename [tk_getSaveFile \
    -defaultextension "" \
    -filetypes "" \
    -initialfile tkxg.ps \
    -parent .tkxg \
    -title {Save plot Postscript}]

  if {$filename == ""} {
    return 1;
  } else {
    set win .tkxg.c
    set corners [$win bbox all]
    set x [lindex $corners 0]
    set y [lindex $corners 1]
    set w [expr [lindex $corners 2] - $x]
    set h [expr [lindex $corners 3] - $y]
    set ar [expr (1.0*$w)/(1.0*$h)]
    set rotate 0
# don't scale to file.
#   set pageopt "-pagewidth 6.5i"
#   if {$ar < 0.7222222222} { set pageopt "-pageheight 9.0i" }
#   if {$ar > 1.3846} { set pageopt "-pagewidth 9.0i"; set rotate 1 }
    #eval $win postscript -file $dispfile -x $x -y $y -width $w \
        #-height $h -rotate $rotate $pageopt
    $win postscript -file $filename -x $x -y $y -width $w \
        -height $h
    puts "Wrote file $filename."
  }
}

proc Tkxg_Destroy_and_exit {} {
  foreach i [info comm xgraph*] {
    $i destroy
  }
  exit
}

# set default for line drawing.
proc Tkxg_cseg {color width stipple class} {
  global __tkxgrender __tkxg_current
  if {$class >=0} {
    set __tkxgrender(linecolor) [$__tkxg_current cget -seriescolor $class]
    set __tkxgrender(linewidth) [$__tkxg_current cget -serieswidth $class]
    set __tkxgrender(linestipple) [$__tkxg_current cget -seriesstipple $class]
  } else {
    set __tkxgrender(linecolor) $color
    set __tkxgrender(linewidth) $width
    set __tkxgrender(linestipple) $stipple
  }
}

# draw line using global color,width,stipple. dashpatch might be nice.
# assumes a proper prior call to Tkxg_cseg
proc Tkxg_seg {x1 y1 x2 y2 class} {
  global __tkxgrender __tkxg_current
  .tkxg.c create line $x1 $y1 $x2 $y2 \
             -fill $__tkxgrender(linecolor) \
             -width $__tkxgrender(linewidth) \
             -tags $__tkxg_current.line.$class
#            -stipple $__tkxgrender(linestipple) \
}

# Draw text
proc Tkxg_text {val x y anchor font class} {
  global __tkxg_current
  .tkxg.c create text $x $y \
     -text $val \
     -anchor $anchor \
     -font $font \
     -tags $__tkxg_current.text.$class
}

# style 0 = pixel of color
# style 1 = dot of color
# style 2 = bitmap of seriescolor and name given.
global __tkxgmarkers
set __tkxgmarkers(0) tkxg_mark1
set __tkxgmarkers(1) tkxg_mark2
set __tkxgmarkers(2) tkxg_mark3
set __tkxgmarkers(3) tkxg_mark4
set __tkxgmarkers(4) tkxg_mark5
set __tkxgmarkers(5) tkxg_mark6
set __tkxgmarkers(6) tkxg_mark7
set __tkxgmarkers(7) tkxg_mark8

proc Tkxg_InitMarkers {} {
  global __tkxg_current __tkxgmarkers
  set n [$__tkxg_current maxsets]
  puts "Series: $n"
  for {set i 0} {$i < $n} {incr i} {
    $__tkxg_current configure \
      -seriesmarker $i $__tkxgmarkers([expr $i % 8])
  }
}

# possible optimization: can cseg set the color for use here?
proc Tkxg_dot {x y style type color class} {
  global __tkxgmarkers __tkxg_current
  switch $style {
  {0} {.tkxg.c create rectangle $x $y $x $y \
                                -fill $color \
                                -tags $__tkxg_current.mark.$class;
      } 
  {1} {.tkxg.c create oval [expr $x - 2] [expr $y -2] \
                           [expr $x + 2] [expr $y + 2] \
                           -fill $color \
                           -tags $__tkxg_current.mark.$class; 
      }
  {2} {set mark [$__tkxg_current cget -seriesmarker $class]
       switch $mark {
       pixel {.tkxg.c create bitmap $x $y -bitmap apixel \
                -foreground [$__tkxg_current cget -seriescolor $class] \
                -tags $__tkxg_current.mark.$class;
             }
       dot {.tkxg.c create bitmap $x $y \
              -bitmap tkxg_dot \
              -foreground [$__tkxg_current cget -seriescolor $class] \
              -background "" \
              -tags $__tkxg_current.mark.$class; 
           }
       default {.tkxg.c create bitmap  $x $y  \
                  -bitmap  [$__tkxg_current cget -seriesmarker $class] \
                  -foreground [$__tkxg_current cget -seriescolor $class] \
                  -background "" \
                  -tags $__tkxg_current.mark.$class;
               }
       }
      }
  default {.tkxg.c create rectangle [expr $x - 4] [expr $y -4] \
              [expr $x + 4] [expr $y + 4] \
              -fill [$__tkxg_current cget -seriescolor $class] \
              -tags $__tkxg_current.mark.$class;
          }
  }
}

proc Tkxg_SeeAll {} {
  .tkxg.c configure -scrollregion [.tkxg.c bbox all]
}
#
# pops up the ascparmbox for most of the tkxg options
#
proc Tkxg_Reconfigure {} {
  global __tkxg_current __tkxg_opt
  if {"[info comm $__tkxg_current]"==""} {
    error "No xgraphs are defined" \
      "This isn't really a tkxg error, but a user error." 
  }
  # call the gizmo here after setting defaults
  trace vdelete __tkxg_opt w Tkxg_traceopts
  catch {unset __tkxg_opt(namelist)}
  set __tkxg_opt(toplevel) .tkxgopts
  set __tkxg_opt(title) "Tkxgraph Controls"
  set __tkxg_opt(whenokcommand) Tkxg_PlotCurrent
  set __tkxg_opt(helpcommand) xghelp
  set __tkxg_opt(maxlines) 15
  set __tkxg_opt(grab) 0
  set __tkxg_opt(onesize) 0
  set __tkxg_opt(entrywidth) 40 
  set seriescounter 0
  set pagecounter 0
  foreach i [$__tkxg_current configure] {
    set opt [lindex $i 0]
    set type [lindex $i 2]
    if {$type == "Font"} {
      continue;
    }
    if {[string range $opt 0 2]=="-se"} {
      set len [$__tkxg_current maxsets]
      if {[expr $seriescounter + $len] > \
          $__tkxg_opt(maxlines) && $seriescounter != 0} {
        set seriescounter 0
        incr pagecounter
      }
      for {set j 0} {$j < $len} {incr j} {
        incr seriescounter
        lappend __tkxg_opt(namelist) $opt$j
        set __tkxg_opt($opt$j.label) "$opt $j"
        set __tkxg_opt($opt$j) [$__tkxg_current cget $opt $j]
        set __tkxg_opt($opt$j.page) [expr $pagecounter + 4]
        switch $type {
          {Text} {
            set __tkxg_opt($opt$j.type) string
          }
          {Bitmap} {
            set __tkxg_opt($opt$j.type) string
          }
          {Boolean} {
            set __tkxg_opt($opt$j.type) bool
          }
          {Jump} -
          {Double} {
            set __tkxg_opt($opt$j.type) real
          }
          {BorderWidth} -
          {barWidth} -
          {Height} -
          {Width} {
            set __tkxg_opt($opt$j.type) int
            set __tkxg_opt($opt$j.lo) 0
            switch $type {
              {BorderWidth} {
                set __tkxg_opt($opt$j.hi) 10
              }
              {BarWidth} {
                set __tkxg_opt($opt$j.hi) 200
              }
              {Height} {
                set __tkxg_opt($opt$j.hi) [expr [winfo screenheight .] - 20]
                puts $__tkxg_opt($opt$j.hi)
              }
              {Width} {
                set __tkxg_opt($opt$j.hi) [expr [winfo screenwidth .] - 20]
              }
            }
          }
        }
      }
    } else {
      lappend __tkxg_opt(namelist) $opt
      set __tkxg_opt($opt.label) $opt
      set __tkxg_opt($opt) [lindex $i 4]
      set __tkxg_opt($opt.page) 1
      switch $type {
        {Text} {
          set __tkxg_opt($opt.type) string
          set __tkxg_opt($opt.page) 1
        }
        {Bitmap} {
          set __tkxg_opt($opt.type) string
          set __tkxg_opt($opt.page) 3
        }
        {Boolean} {
          set __tkxg_opt($opt.type) bool
          set __tkxg_opt($opt.page) 2
        }
        {Jump} -
        {Double} {
          set __tkxg_opt($opt.type) real
        }
        {BorderWidth} -
        {barWidth} -
        {Height}  -
        {Width} {
          set __tkxg_opt($opt.type) int
          set __tkxg_opt($opt.lo) 0
          set __tkxg_opt($opt.page) 3
          switch $type {
            {BorderWidth} {
              set __tkxg_opt($opt.hi) 10
            }
            {BarWidth} {
              set __tkxg_opt($opt.hi) 200
            }
            {Height} {
              set __tkxg_opt($opt.hi) [expr [winfo screenheight .] - 20]
              puts $__tkxg_opt($opt.hi)
            }
            {Width} {
              set __tkxg_opt($opt.hi) [expr [winfo screenwidth .] - 20]
            }
          }
        }
      }
    }
  }
  set __tkxg_opt(npages) [expr 4 + $pagecounter]
  ascParPage __tkxg_opt +[winfo x .tkxg]+[winfo y .tkxg] 1
  trace variable __tkxg_opt w Tkxg_traceopts
}

proc Tkxg_finish {} {
  Tkxg_SeeAll
  wm deiconify .tkxg
  update; update idletasks
}

proc xghelp {args} {
  puts "options of [info comm xgraph*] are:"
  foreach i [xgraph0 congfigure] {
     if {[string range $i 0 2] == "-se"} {
       puts "[lindex $i 0] <series-number> <[lindex $i 2]>"
     } else {
       puts "[lindex $i 0] <[lindex $i 2]>"
     }
     puts "there are also plot, destroy, maxsets, and resource subcommands"
  }
  puts "for example: xgraph0 configure -yhigh 100 -seriescolor 0 blue"
  puts "Change the options then hit the redraw button."
}

proc Tkxg_dump {i} {
  foreach j [$i configure] {
    puts $j 
  }
  foreach j [$i configure] {
    puts [$i cget [lindex $j 0]]
    if {"[$i cget [lindex $j 0]]" == "SERIES RANGE ERROR"} {
      for {set k 0} {$k < [$i maxsets]} {incr k} {
        puts [$i cget [lindex $j 0] $k]
      }
    }
  }
}

# standard options, more or less.
#-barbase BarBase Jump 0.0 0
#-bargraph BarGraph Boolean 0 0
#-barwidth BarWidth barWidth #-1.0 0
#-bordercolor Border Foreground {black} {black}
#-borderwidth BorderSize BorderWidth 2 2
#-boundingbox BoundBox Boolean 0 0
#-gridwidth GridSize BorderWidth 0 0
#-gridstipple GridStipple Bitmap {tkxgraph_bits_0} {tkxgraph_bits_0}
#-height Height Height 600 600
#-labelfont LabelFont Font {#-*#-helvetica#-*#-r#-*#-*#-12#-*}
#-logx LogX Boolean 0 0
#-logy LogY Boolean 0 0
#-mm Markers Boolean 0 0
#-mM StyleMarkers Boolean 0 0
#-mp PixelMarkers Boolean 0 0
#-mP LargePixels Boolean 0 0
#-negatex NegateX Boolean 0 0
#-negatey NegateY Boolean 0 0
#-nolines NoLines Boolean 0 1
#-serieslegend SeriesName%d Text {Set %d} {}
#-seriescolor SeriesColor%d Foreground {} {}
#-serieswidth SeriesWidth%d BorderWidth {0} {}
#-seriesmarker SeriesMark%d Bitmap {pixel} {}
#-seriesstipple SeriesStip%d Bitmap {tkxgraph_bits_0} {}
#-ticks Ticks Boolean 0 0
#-title TitleText Text {X Graph} {Structural Analysis}
#-titlefont TitleFont Font {#-*#-helvetica#-*#-r#-*#-*#-18#-*} 
#-width Width Width 600 600
#-xhigh XHighLimit Double 0.0 0
#-xlow XLowLimit Double 1.0 1
#-xtitle XUnitText Text {X} {Variables}
#-yhigh YHighLimit Double 0.0 0
#-ylow YLowLimit Double 1.0 1
#-ytitle YUnitText Text {Y} {Relations}
#-zerocolor ZeroColor Foreground {white} {white}
#-zerowidth ZeroWidth BorderWidth 0 0

puts "For help, type xghelp or info comm Tkxg_*"


###########################################################################
 #if not defined
if {[info vars ascParPageVext(title)]==""} {
#-serieslegend SeriesName%d Text {Set %d} {}
#-title TitleText Text {X Graph} {Structural Analysis}
# ascparm.tcl
# Tcl version: 8.0
# Tk version: 8.0
# XF version: 2.2
# ----------------------------------------------------------------------
# Flexible parameters (real, string, int, bool, bin) entry window with sanity
# checking built in.
# May 2, 1994. Benjamin Allan.
# Given a global array variable, build an appropriate window to get good
# data.
# Error handling is done in 2 associated procedures (ascParSane,
# ascParPageClose using Tk builtin function error. This may be revised
# to suit your application.
# Note: I have incorporated the MenuPopup bindings (under local names)
# so that this is stand alone. the standard bindings found in xf for
# popups have been renamed to AP_MenuPop* from MenuPop*. If the menu
# behavior in Tk 4.x is changed, these routines need to be updated.
# $Revision: 1.7 $
# $Date: 97/06/16 19:11:42 $
# ----------------------------------------------------------------------


global ascParPageVect
 # set demo vars
set ascParPageVect(namelist) "mywstring mystringlist myreallylonglonglongbool myreal myint mybin"
set ascParPageVect(title) "My_window_title"
set ascParPageVect(toplevel) ".mywindow"
set ascParPageVect(maxlines) "10"
set ascParPageVect(npages) "2"
set ascParPageVect(myint) 2
set ascParPageVect(myint.lo) 2
set ascParPageVect(myint.type) int
set ascParPageVect(mybin) 2
set ascParPageVect(mybin.hi) 3
set ascParPageVect(mybin.type) bin
set ascParPageVect(myreallylonglonglongbool) 1
set ascParPageVect(myreallylonglonglongbool.page) 2
set ascParPageVect(myreallylonglonglongbool.type) bool
set ascParPageVect(mystringlist.page) 2
set ascParPageVect(myreal) 1.34e-2
set ascParPageVect(myreal.type) real
set ascParPageVect(mywstring) "bite me!"
set ascParPageVect(mywstring.choices) ""
set ascParPageVect(mystringlist) "bite me!"
set ascParPageVect(mystringlist.choices) "fred barney"
set ascParPageVect(grab) "1"
set ascParPageVect(helpcommand) "puts no_help"
set ascParPageVect(whenokcommand) "puts ok_pressed"
set ascParPageVect(whenokcommand) "puts userchecked"

#
# proc ascParPage {{PA} {position "+10+10"} {page "1"}}
# ----------------------------------------------------------------------
# Selfdemo:  ascParPage ascParPageVect
#  This procedure creates a window of entryL's and toggle buttons to
#  get user input for the vector {PA}. {PA} has to know a little
#  about itself and how it should be windowed, for example:
#
#  ${PA}(namelist) "myint mybool myreal mywstring mystringlist"
#  ${PA}(title) "My_window_title"
#  ${PA}(toplevel) ".mywindow"
#  ${PA}(maxlines) "10"
#  this is a per page limit
#  ${PA}(npages) "1"
#  max we will look at, overrides maxlines
#  ${PA}(grab) "0"
#  ${PA}(usercheckcommand) "puts nousercheck"
#  called with the name of the array after all the range checks are passed.
#  If the user detects something not good about the array state, they
#  should exit their checking function by a call to tcl error with an
#  appropriate message. Supplying a usercheckcommand is optional.
#  ${PA}(whenokcommand) "puts values_in_bounds"
#  done when input checks
#  ${PA}(helpcommand) "puts no_help"
#  done when help is pushed
#
#  If ${PA}(onesize) is true, all pages will be as long as the longest page,
#  otherwise the window will resize itself depending on item count on that
#  page. The pages will vary by a few pixels if the number of booleans on the
#  page is different.
#
#  If these are not set, dumb defaults will be applied for all.
#  If you specify garbage for the above, the window may not build
#  correctly. This is your fault.
#
#  position should be any string valid for the wm geometry command in tk
#  page is the page to displaying, if there are more than 1 pages
#
#  Each element in ${PA}(namelist) will be given a line in the
#  input window and used as a widget name, so each should start with
#  a lowercase letter. On exit, ${PA}(name) will be assigned a value
#  from the user input.
#  Bounds are applied to real and integer variables and error messages
#  generated sometime before the whenokcommand is executed. Similarly, strings
#  are checked against a choice list if one is provided.
#  This check/execute cycle takes place when the user pushes the ok button.
#  The window is destroyed after check is passed and before whenokcommand
#  is called. Arguments must be sane before window is closed, but if the
#  window is up with a bad value, any place else accessing the same
#  global variable will still see the bad value. Grab may be of use in
#  reducing this kind of error.
#
#  Input format is controlled by the following modifiers in ${PA}:
#  ${PA}($name.type) [bool,int,real,string]
#  ${PA}($name.lo) ${PA}($name.hi)  input range limits for real,int
#  ${PA}($name.choices) list of valid strings for $name. if null, any
#  string value is valid.
#  ${PA}($name.label) descriptive text for widget. if null, label :=name
#  ${PA}($name.page) number of page a variable should be displayed on,
#  if $name.page > ${PA}(npages), will be reset to the last page
#  ***The sanity of type, lo, hi, choices will not be checked if they are ***
#  specified. Some defaults will be assumed if they left unspecified.
#  Defaults: type- string, lo- -infinity, hi- +infinity, choices- anything
#
#  The line widgets are built using the following parameters in ascParPageVect:
#  pagebg
#  pagefg
#  entrybg  (the active version of fg/bg will be inverse of this pair
#  entryfg
#  entryrelief
#  entryborder
#  entrywidth
#    entrywidth may be overridden by entrywidth being defined in ${PA}
#  checkfg  (the active version of fg/bg will be inverse of this pair
#  checkbg
#  checksel
#  btn_font
#  lbl_font
 set ascParPageVect(pagefg) black
 set ascParPageVect(pagebg) white
 set ascParPageVect(entrybg) white
 set ascParPageVect(entryfg) black
 set ascParPageVect(entryrelief) groove
 set ascParPageVect(entryborder) 3
 set ascParPageVect(entrywidth) 12
 set ascParPageVect(checkbg) white
 set ascParPageVect(checkfg) black
 set ascParPageVect(checksel) black
 global tcl_platform
 if {$tcl_platform(platform)== "unix"} {
   set ascParPageVect(btn_font) {helvetica 12 bold}
   set ascParPageVect(lbl_font) {helvetica 12 bold}
 } else {
   set ascParPageVect(btn_font) system
   set ascParPageVect(lbl_font) system
 }
 set ascParPageVect(onesize) 1
#
 # aliased operations on vectors are tricky:
 # reading:  set "${ary}(subscript)" returns the value we
 # would incorrectly think of as $alias(subscript)
 # setting:  set "${ary}(subscript)" value works well
 # fortunately most of this is fixed in tcl8 with upvar #0
# ----------------------------------------------------------------------
proc ascParPage {{ap "ascParPageVect"} {position "+10+10"} {page "1"}} {
  global ascParPageVect
  upvar #0 $ap PA
  global $ap


 # preprocess the vector {PA}
  if {[info exists PA(namelist)]==0} {
    error "ascParPage called with vector missing namelist"
  }
  set lentrywidth "$ascParPageVect(entrywidth)"
  catch {set lentrywidth $PA(entrywidth)}
  if {[info exists PA(npages)]==0} { set PA(npages) 1 }
  if {[info exists PA(maxlines)]==0} { set PA(maxlines) 15 }
  if {[info exists PA(toplevel)]==0} { set PA(toplevel) apptop }
  if {[info exists PA(title)]==0} { set PA(title) $ap}
  if {[info exists PA(onesize)]==0} { set PA(onesize) 1}
  if {[info exists PA(grab)]==0} { set PA(grab) 1}
  if {$PA(npages) <0} {set PA(npages) 1}
  if {$page > $PA(npages)} { set page 1}
  set nlist $PA(namelist)
  # nlist used way too much to array deref all the time
  foreach i $nlist {
    if {[info exists PA($i)] == 0}       {set PA($i) 1}
    if {[info exists PA($i.type)] == 0}  {set PA($i.type) string}
    if {[info exists PA($i.label)] == 0} {set PA($i.label) $i}
    if {[info exists PA($i.page)] == 0}  {set PA($i.page) 1}
    if {[info exists PA($i.choices)] == 0 && $PA($i.type)=="string"} {
      set PA($i.choices) ""
    }
    if {$PA($i.page) > $PA(npages)} { set PA($i.page) $PA(npages) }
  }
  set npages $PA(npages)
  # get longest page length
  if {[info exists PA(maxppitems)] == 0} {
    set PA(itemsperpage) 0
    set thispage 0
    set max 0
    for {set i 1} {$i <= $npages} {incr i} {
      set thispage 0
      foreach l $nlist {
        if {$i == $PA($l.page)} {incr thispage}
      }
      if {$thispage > $max } {set max $thispage}
      set PA(itemsperpage) "$PA(itemsperpage) $thispage"
    }
    set PA(maxppitems) $max
  }
  set lwidth 0
  set tl $PA(toplevel)
  # build widget .$PA(toplevel)
  if {[winfo exists $tl]} {
     set upalready 1
  } else {set upalready 0}
  if {!$upalready} {
  # get page width in chars. it is the greater of 6 + len biggest boolean label
  #   and (entrywidth + len biggest non-boolean label)
    set bwidth 0
    set ewidth 0
    foreach i $nlist {
      set type $PA($i.type)
      if {$type =="bool" &&
          [string length $PA($i.label)] > $bwidth} {
        set bwidth [string length $PA($i.label)]
      }
      if {($type =="real" || $type =="int" || $type =="string") && \
          [string length $PA($i.label)] > $ewidth } {
        set ewidth [string length $PA($i.label)]
      }
    }
    set lwidth [expr $ewidth + $lentrywidth +5]
    if { $ewidth + $lentrywidth < $bwidth+6} {
      set lwidth [expr $bwidth+6]
    }

    toplevel $tl

    # Window manager configurations
    global tk_version
    wm positionfrom $tl user
    wm sizefrom $tl user
    wm iconname $tl $PA(title)
    wm title $tl $PA(title)
    wm geometry $tl $position

    # build all the widgets, visible or invisible
    foreach i $nlist {
      set type $PA($i.type)
      if {$type=="string" && [info exists PA($i.choices)] && \
           $PA($i.choices) != ""} {
        set type menustring
      }
      if {$type =="int" ||  $type =="real" || \
          $type =="string" || $type =="bin"} {
        # build widget .$PA(toplevel).val_frm_$i
        frame $tl.val_frm_$i

        # build widget .$PA(toplevel).val_frm_$i.entry5
        entry $tl.val_frm_$i.entry5 \
          -font $ascParPageVect(lbl_font) \
          -borderwidth $ascParPageVect(entryborder) \
          -exportselection 0 \
          -textvariable "${ap}($i)" \
          -width $lentrywidth
        bind $tl.val_frm_$i.entry5 <Leave> "ascParSane %W $ap"

        # build widget .$PA(toplevel).val_frm_$i.label4
        label $tl.val_frm_$i.label4 \
          -font $ascParPageVect(lbl_font) \
          -borderwidth {0} \
          -text $PA($i.label)

        # pack widget .$PA(toplevel).val_frm_$i
        pack append $tl.val_frm_$i \
          $tl.val_frm_$i.label4 {left frame w fillx} \
          $tl.val_frm_$i.entry5 {right frame e filly}
      }
      if {$type =="menustring" } {
        # build widget .$PA(toplevel).val_frm_$i
        frame $tl.val_frm_$i

        # build widget .$PA(toplevel).val_frm_$i.entry5
        entry $tl.val_frm_$i.entry5 \
          -font $ascParPageVect(lbl_font) \
          -exportselection 0 \
          -borderwidth $ascParPageVect(entryborder) \
          -textvariable "${ap}($i)" \
          -width $lentrywidth
        bind $tl.val_frm_$i.entry5 <Leave> "ascParSane %W $ap"

        # popup m1 bindings
        bind $tl.val_frm_$i.entry5 <Button-1> \
          "AP_MenuPopupPost $tl.val_frm_$i.entry5.menu0 %X %Y"
        bind $tl.val_frm_$i.entry5 <ButtonRelease-1> \
          "AP_MenuPopupRelease $tl.val_frm_$i.entry5.menu0 %W"

        # build widget $tl.val_frm_$i.entry5.menu0
        menu $tl.val_frm_$i.entry5.menu0 \
          -tearoff 0
        foreach me $PA($i.choices) {
          $tl.val_frm_$i.entry5.menu0 add command \
            -font $ascParPageVect(lbl_font) \
            -command "set ${ap}($i) \{$me\}" \
            -label $me
        }
        # bindings
        bind $tl.val_frm_$i.entry5.menu0 <B1-Motion> \
          "AP_MenuPopupMotion $tl.val_frm_$i.entry5.menu0 %W %X %Y"
        bind $tl.val_frm_$i.entry5.menu0 <ButtonRelease-1> \
          "AP_MenuPopupRelease $tl.val_frm_$i.entry5.menu0 %W"

        # build widget .$PA(toplevel).val_frm_$i.label4
        label $tl.val_frm_$i.label4 \
          -font $ascParPageVect(lbl_font) \
          -borderwidth {0} \
          -padx {2} \
          -text $PA($i.label)

        # pack widget .$PA(toplevel).val_frm_$i
        pack append $tl.val_frm_$i \
          $tl.val_frm_$i.label4 {left frame w fillx} \
          $tl.val_frm_$i.entry5 {right frame e filly}
      }
      if {$type =="bool"} {
        # build widget .$PA(toplevel).bool_frm_$i
        frame $tl.bool_frm_$i

        # build widget .$PA(toplevel).bool_frm_$i.btn2
        checkbutton $tl.bool_frm_$i.btn2 \
          -borderwidth {1} \
          -text {} \
          -variable "${ap}($i)"

        # build widget .$PA(toplevel).bool_frm_$i.lbl1
        label $tl.bool_frm_$i.lbl1 \
          -font $ascParPageVect(lbl_font) \
          -borderwidth $ascParPageVect(entryborder) \
          -text $PA($i.label)

        # pack widget .${PA}(toplevel).bool_frm_$i
        pack append $tl.bool_frm_$i \
          $tl.bool_frm_$i.btn2 {left frame w filly} \
          $tl.bool_frm_$i.lbl1 {top frame w filly}
      }
    }
#end for loop widget creation
    # build widget .${PA}(toplevel).btn_hlp
    button $tl.btn_hlp \
      -font $ascParPageVect(btn_font) \
      -command "$PA(helpcommand)" \
      -text {  Help  }

    # build widget .$PA(toplevel).btn_more
    button $tl.btn_more \
      -font $ascParPageVect(btn_font) \
      -command "ascParPage $ap $position 2" \
      -text {More}

    # build widget $tl.btn_ok
    button $tl.btn_ok \
      -font $ascParPageVect(btn_font) \
      -command "ascParPageClose $ap" \
      -text {  OK   }
  }
# end widget construction

  foreach i [winfo children $tl] {pack forget $i}
  catch {foreach i [winfo children $tl.pad] {pack forget $i} }

#pack current page set in int/real/string/bin/bool order
    # pack widget .$PA(toplevel)
  foreach j "int real string bin bool" {
    foreach i $nlist {
      set type $PA($i.type)
      if {$PA($i.page)==$page && $j==$type} {
        if {$type=="int" || $type=="real" || $type=="string" || $type=="bin"} {
          pack append $tl \
           $tl.val_frm_$i {top frame center fill} \
        }
        if {$type=="bool"} {
          pack append  $tl \
            $tl.bool_frm_$i {top frame w filly} \
        }
      }
    }
  }
  catch {
    # build widget $tl.pad
    frame $tl.pad  -borderwidth 0
  }
  set en 0
  if {$PA(onesize)} {
    set en [expr $PA(maxppitems) - [lindex $PA(itemsperpage) $page]]
  }

  # build widget $tl.pad.entry$ep
  if {$PA(onesize)} {
    for {set ep 0} {$ep<$en} {incr ep} {
      catch {
        entry $tl.pad.entry$ep \
          -state disabled \
          -borderwidth $ascParPageVect(entryborder) \
          -exportselection 0 \
          -font $ascParPageVect(lbl_font) \
          -relief flat \
          -highlightthickness 0 \
          -width $lwidth
      }
    }
  }

  # build widget $tl.pad.entry
  catch {entry $tl.pad.entry \
      -state disabled \
      -exportselection 0 \
      -font $ascParPageVect(lbl_font) \
      -borderwidth $ascParPageVect(entryborder) \
      -relief flat \
      -highlightthickness 0 \
      -width $lwidth
  }

  pack append $tl.pad $tl.pad.entry {top frame center expand fill}
  if {$PA(onesize)} {
    for {set ep 0} {$ep<$en} {incr ep} {
       pack append $tl.pad $tl.pad.entry$ep {top frame center expand fill}
    }
  }

  pack append $tl \
      $tl.pad {top frame n fill } \
      $tl.btn_ok {left frame sw} \
      $tl.btn_hlp {right frame se}
  if {$PA(npages) >1} {
  pack append $tl \
      $tl.btn_more {top frame center expand fill}
  $tl.btn_more config \
    -command "ascParPage $ap \"\" [incr page]"
  }
  if {$PA(grab)} {
    tkwait window $tl
  }
}

#
# proc ascparpagebinary {bv}
# ----------------------------------------------------------------------
# returns a doublet {$sane $br}
# sane is 1 if bv given becomes a binary number
# sane is 0 otherwise
# the br returned will have any non-binary digits # hacked out
# ----------------------------------------------------------------------
proc ascparpagebinary {bv} {
  regsub -all \[^01\] $bv "" br
  if {![info exists br] || [string length $br]==0} {
    return [list 0 {}]
  } else {
    return [list 1 $br]
  }
}

#
# proc ascParSane {name ap}
# ----------------------------------------------------------------------
# Return 0 if the value entered meets specs, or 1 if not
# If variable is of unknown type or boolean, returns 0.
# Name starts with . (is a widget) the variable of the widget
# (entry assumed) is used, otherwise name is treated as if
# part of PA.
# On string sanity, the user entered val will be string matched
# (lsearch) against choice list if given, and then the variable value
# will be set to the match from the choice list.
# Numeric variables will be truncated if integer is called for.
# ----------------------------------------------------------------------
proc ascParSane {name ap} {
  upvar #0 $ap PA
  global $ap
  set base $name
 # we want to arrive at
 # base is variable to be checkeds subscript as in namelist
 # name is actual full global variable name
  if {[string range $name 0 0] == "."} { # if widget
    # name is the widget
    set name [lindex [$name configure -textvariable] 4]
    global $name
    set base [string trim [lindex [split $name (] 1] )]
  } else {
    set name $ap
    append name ( $base )
  }
  set val [set $name]
  set type $PA($base.type)
  switch $type {
    {bin} {
      set bstat "[ascparpagebinary $val]"
      set saneval "[lindex $bstat 1]"
      if {[lindex $bstat 0]} {
        set $name $saneval
        if {[info exists PA($base.hi)]} {
          if {[string length $saneval] > $PA($base.hi)} {
             puts stderr "$PA($base.label) is too long.";
             puts stderr "Length limit: $PA($base.hi)";
             return 1
          }
        }
        return 0
      } else {
        return 2
      }
    }
    {int} {
      if { [scan $val %d saneval] } {
        if {[info exists PA($base.lo)]} {
          if {$saneval < $PA($base.lo)} {
            puts stderr "$PA($base.label) is too low";
            puts stderr "lower limit: $PA($base.lo)";
            set $name $PA($base.lo)
            return 1
          }
          set $name $saneval
        }
        if {[info exists PA($base.hi)]} {
          if {$saneval > $PA($base.hi)} {
             puts stderr "$PA($base.label) is too high";
             puts stderr "upper limit: $PA($base.hi)";
             set $name $PA($base.hi)
             return 1
          }
          set $name $saneval
        }
        return 0
      } else {
        return 2
      }
    }
    {real} {
      if { [scan $val %g saneval] } {
        if {[info exists PA($base.lo)]} {
          if {$saneval < $PA($base.lo)} {
            puts stderr "$PA($base.label) is too low";
            puts stderr "lower limit: $PA($base.lo)";
            set $name $PA($base.lo)
            return 1
          }
          set $name $saneval
        }
        if {[info exists PA($base.hi)]} {
          if {$saneval > $PA($base.hi)} {
            puts stderr "$PA($base.label) is too high";
            puts stderr "upper limit: $PA($base.hi)";
            set $name $PA($base.hi)
            return 1
          }
          set $name $saneval
        }
        return 0
      } else {
        return 2
      }
    }
    {string} {
      if {$PA($base.choices)!=""} {
        set match [lsearch -exact $PA($base.choices) $val]
        if {$match== "-1"} {
          puts stderr  "$PA($base.label) not among choices:";
          set c $PA($base.choices)
          foreach i $c {puts stderr $i}
          return 1
        } else {
          set $name [lindex $PA($base.choices) $match]
          return 0
        }
      }
    }
    default {return 0}
  }
  return 1
}

# ----------------------------------------------------------------------
# checks sanity and handles error reporting for all variables
# before closing window.
# ----------------------------------------------------------------------
proc ascParPageClose {ap} {
  upvar #0 $ap PA
  global $ap
  foreach i $PA(namelist) {
    if {[set code [ascParSane $i $ap]]} {
      switch $PA($i.type) {
        {bin} {
          if {$code=="2"} {
            error "Entered value for $i is non-binary."
          } else {
            set lo "0 <"
            set hi 32
            catch { set hi "< $PA($i.hi)"}
            set binhi 1
            for {set bk 1} {$bk < $hi} {incr bk} {
              set binhi "${binhi}1"
            }
            error "Entered value out of range: $lo $PA($i.label) $binhi."
          }
        }
        {int} -
        {real} {
          if {$code=="2"} {
            error "Entered value for $i is non-numeric."
          } else {
            set lo "-infinity <"
            set hi "< infinity"
            catch { set lo "$PA($i.lo) <"}
            catch { set hi "< $PA($i.hi)"}
            error "Entered value out of range: $lo $PA($i.label) $hi."
          }
        }
        {string} {
          if {$PA($i.choices)!=""} {
            set val $PA($i)
            set match [lsearch -exact $PA($i.choices) $val]
            if {$match== "-1"} {
              set irname $PA($i.label);
              set c $PA($i.choices)
              set report "Entered value for $irname not found in choices: $c"
              error $report
            }
          }
        }
        default { puts "\aInsanity ignored on unknown type."}
      }
    }
  }
  set msg ""
  if {[info exists PA(usercheckcommand)] && \
      [catch {$PA(usercheckcommand) $ap} parpagemsg]} {
    error $parpagemsg
  }
  destroy $PA(toplevel)
  eval $PA(whenokcommand)
}

#
# AP_MenuPopup
#----------------------------------------------------------------
# The following binding functions have been simply renamed from
# a version of xf2.2/tcl7.1/tk3.4 so this file stands alone.
#----------------------------------------------------------------
# Procedure: AP_MenuPopupMotion
##########
# Procedure: AP_MenuPopupMotion
# Description: handle the popup menu motion
# Arguments: xfMenu - the topmost menu
#            xfW - the menu
#            xfX - the root x coordinate
#            xfY - the root x coordinate
# Returns: none
# Sideeffects: none
##########
proc AP_MenuPopupMotion { xfMenu xfW xfX xfY} {
  global tk_popupPriv

  if {"[info commands $xfW]" != "" && [winfo ismapped $xfW] &&
      "[winfo class $xfW]" == "Menu" &&
      [info exists tk_popupPriv($xfMenu,focus)] &&
      "$tk_popupPriv($xfMenu,focus)" != "" &&
      [info exists tk_popupPriv($xfMenu,grab)] &&
      "$tk_popupPriv($xfMenu,grab)" != ""} {
    set xfPopMinX [winfo rootx $xfW]
    set xfPopMaxX [expr $xfPopMinX+[winfo width $xfW]]
    if {$xfX >= $xfPopMinX && $xfX <= $xfPopMaxX} {
      $xfW activate @[expr $xfY-[winfo rooty $xfW]]
      if {![catch "$xfW entryconfig @[expr $xfY-[winfo rooty $xfW]] -menu" result]} {
        if {"[lindex $result 4]" != ""} {
          foreach binding [bind $xfMenu] {
            bind [lindex $result 4] $binding [bind $xfMenu $binding]
          }
        }
      }
    } {
      $xfW activate none
    }
  }
}

##########
# Procedure: AP_MenuPopupPost
# Description: post the popup menu
# Arguments: xfMenu - the menu
#            xfX - the root x coordinate
#            xfY - the root x coordinate
# Returns: none
# Sideeffects: none
##########
proc AP_MenuPopupPost { xfMenu xfX xfY} {
  global tk_popupPriv

  if {"[info commands $xfMenu]" != ""} {
    if {![info exists tk_popupPriv($xfMenu,focus)]} {
      set tk_popupPriv($xfMenu,focus) [focus]
    } {
      if {"$tk_popupPriv($xfMenu,focus)" == ""} {
        set tk_popupPriv($xfMenu,focus) [focus]
      }
    }
    set tk_popupPriv($xfMenu,grab) $xfMenu

    catch "$xfMenu activate none"
    catch "$xfMenu post $xfX $xfY"
    catch "focus $xfMenu"
    catch "grab -global $xfMenu"
  }
}

##########
# Procedure: AP_MenuPopupRelease
# Description: remove the popup menu
# Arguments: xfMenu - the topmost menu widget
#            xfW - the menu widget
# Returns: none
# Sideeffects: none
##########
proc AP_MenuPopupRelease { xfMenu xfW} {
  global tk_popupPriv
  global tk_version

  if {"[info commands $xfW]" != "" && [winfo ismapped $xfW] &&
      "[winfo class $xfW]" == "Menu" &&
      [info exists tk_popupPriv($xfMenu,focus)] &&
      "$tk_popupPriv($xfMenu,focus)" != "" &&
      [info exists tk_popupPriv($xfMenu,grab)] &&
      "$tk_popupPriv($xfMenu,grab)" != ""} {
    if {$tk_version >= 3.0} {
      catch "grab release $tk_popupPriv($xfMenu,grab)"
    } {
      catch "grab none"
    }
    catch "focus $tk_popupPriv($xfMenu,focus)"
    set tk_popupPriv($xfMenu,focus) ""
    set tk_popupPriv($xfMenu,grab) ""
    if {"[$xfW index active]" != "none"} {
      $xfW invoke active; catch "$xfMenu unpost"
    }
  }
  catch "$xfMenu unpost"
}



# eof
#
}
#endif ascparpagevect(title)

###########################################################################
 # ifndef ascfontbox.tcl
global autoLoadList
if {![info exists autoLoadList(ascfontsel.tcl)]} {
# Module: ascfontbox.tcl
# Tcl version: 8.0
# Tk version: 8.0
# XF version: 2.3
#
# By Benjamin Allan
# June 5, 1997
# $Revision: 1.8 $
# $Author: mthomas $
# $Date: 97/06/17 16:00:30 $
# Unlike the rest of the ascend distribution, this widget is
# placed in the public domain.
#
# This module implements a simple tk8 based font selection
# window with an editable text sample.
# The global variable ascFontVect(selected) has the most recently
# selected font at any given time.
# If an answer is required in a particular time, rather than
# through a trace, the function ascFontGet can be called for
# a modal selection process.

# module contents
global moduleList
global ascFontVect
global autoLoadList
set moduleList(ascfontsel.tcl) { .ascfontsel}
set autoLoadList(ascfontsel.tcl) {1}

proc ascFontGet {} {
  global ascFontVect
  ShowWindow.ascfontsel
  ascFont_set_Defaults
  tkwait window .ascfontsel
  if {$ascFontVect(exit_button) == "exit"} {
    return $ascFontVect(selected)
  } else {
    return ""
  }
}

set ascFontVect(family) courier
proc ascFont_set_Defaults {} {
  global ascFontVect
  if {[info exists ascFontVect(inited)]==0} {
    set ascFontVect(inited) 1
    set ascFontVect(windowname) .ascfontsel
    set ascFontVect(normal) 1
    set ascFontVect(italic) 0
    set ascFontVect(bold) 0
    set ascFontVect(underline) 0
    set ascFontVect(overstrike) 0
    set ascFontVect(roman) 0
    set ascFontVect(size) 12
 # broken Sun fonts
    lappend ascFontVect(badlist) \
      {fangsong ti} \
      gothic \
      mincho \
      nil \
      {open look cursor} \
      {song ti} \
      {open look glyph}
    foreach i [lsort [font families] ] {
      if {[lsearch -exact $ascFontVect(badlist) $i] == -1} {
        lappend ascFontVect(goodlist) $i
      }
    }
  }
}

proc ascFont_resetquietly {a s op} {
  global ascFontVect
  trace vdelete ascFontVect w ascFont_configure
  if {$ascFontVect(normal) && $s == "normal"} {
    set ascFontVect(italic) 0
    set ascFontVect(bold) 0
    set ascFontVect(underline) 0
    set ascFontVect(overstrike) 0
    set ascFontVect(roman) 0
  } else {
    if {$s == "italic" || $s =="bold" || $s =="underline" || \
        $s == "overstrike" || $s == "roman"} {
      set ascFontVect(normal) 0
    }
  }
  trace variable ascFontVect w ascFont_configure
}

proc ascFont_fillsamples {} {
  global ascFontVect
  set fontlist $ascFontVect(goodlist)
  set ln 1
  set t .ascfontsel.samp_frm.list2
  $t configure -state normal
  $t delete 1.0 end
  foreach i $fontlist {
    $t insert end $i
    set str "\{$i\}"
    append str " 12 normal"
    $t insert end " 12 normal\n"
    set ascFontVect(font.$ln) "\{$i\}"
    $t tag add font$ln $ln.0 $ln.end
    $t tag configure font$ln -font $str
    $t tag bind font$ln <Button-1> "
      set ascFontVect(family) \$ascFontVect(font.$ln)
    "
    incr ln
  }
  $t configure -state disabled
}

proc ascFont_configure {a s op} {
  global ascFontVect
  set name $ascFontVect(family)
  append name " $ascFontVect(size) "
  if {$ascFontVect(normal)} {
    ascFont_resetquietly $a $s $op
  }
  foreach i {normal italic bold underline overstrike roman} {
    if {$ascFontVect($i)} {
      append name "$i "
    }
  }
  .ascfontsel.frame.entry5 delete 0 end
  .ascfontsel.frame.entry5 insert end $name
  .ascfontsel.test_frm.text2 configure -font $name
  .ascfontsel.test_frm.text2 delete 1.0 end
  regsub @@@ $ascFontVect(sample) $name sample
  .ascfontsel.test_frm.text2 insert end $sample
  return $name
}

proc ascFont_cancel {} {
  global ascFontVect
  set ascFontVect(selected) [ascFont_configure 0 0 0]
  trace vdelete ascFontVect w ascFont_configure
  set ascFontVect(exit_button) {cancel}
  DestroyWindow.ascfontsel
}

proc ascFont_exit {} {
  global ascFontVect
  set ascFontVect(selected) [ascFont_configure 0 0 0]
  trace vdelete ascFontVect w ascFont_configure
  set ascFontVect(exit_button) {exit}
  DestroyWindow.ascfontsel
}

# procedure to show window .ascfontsel
proc ShowWindow.ascfontsel {args} {# xf ignore me 7

  # build widget .ascfontsel
  catch "destroy .ascfontsel"
  toplevel .ascfontsel
  global ascFontVect

  catch {trace vdelete ascFontVect w ascFont_configure}
  ascFont_set_Defaults
  set fontlist $ascFontVect(goodlist)
  # Window manager configurations
  wm positionfrom .ascfontsel ""
  wm sizefrom .ascfontsel program
  wm iconname .ascfontsel {ASCEND Font Picker}
  wm maxsize .ascfontsel 1000 900
  wm geometry .ascfontsel 350x350
  wm minsize .ascfontsel 0 0
  wm title .ascfontsel {ASCEND Font Picker}
  wm protocol .ascfontsel WM_DELETE_WINDOW {ascFont_cancel}


  # build widget .ascfontsel.mb_frm
  frame .ascfontsel.mb_frm

  # build widget .ascfontsel.mb_frm.font_btn
  menubutton .ascfontsel.mb_frm.font_btn \
    -menu {.ascfontsel.mb_frm.font_btn.m} \
    -text {Font}

  # build widget .ascfontsel.mb_frm.font_btn.m
  menu .ascfontsel.mb_frm.font_btn.m \
    -tearoffcommand .ASCFONTSEL.MB_FRM.FONT_BTN.M \
    -tearoff 0

  foreach i $fontlist {
    .ascfontsel.mb_frm.font_btn.m add radiobutton \
      -label $i \
      -value \{$i\} \
      -variable ascFontVect(family)
  }
  # build widget .ascfontsel.mb_frm.style_btn
  menubutton .ascfontsel.mb_frm.style_btn \
    -menu {.ascfontsel.mb_frm.style_btn.m} \
    -text {Styles}

  # build widget .ascfontsel.mb_frm.style_btn.m
  menu .ascfontsel.mb_frm.style_btn.m \
    -tearoffcommand .ASCFONTSEL.MB_FRM.STYLE_BTN.M \
    -tearoff 0

  .ascfontsel.mb_frm.style_btn.m add checkbutton \
    -label {normal} \
    -variable ascFontVect(normal)
  .ascfontsel.mb_frm.style_btn.m add checkbutton \
    -label {italic} \
    -variable ascFontVect(italic)
  .ascfontsel.mb_frm.style_btn.m add checkbutton \
    -label {bold} \
    -variable ascFontVect(bold)
  .ascfontsel.mb_frm.style_btn.m add checkbutton \
    -label {underline} \
    -variable ascFontVect(underline)
  .ascfontsel.mb_frm.style_btn.m add checkbutton \
    -label {overstrike} \
    -variable ascFontVect(overstrike)
  .ascfontsel.mb_frm.style_btn.m add checkbutton \
    -label {roman} \
    -variable ascFontVect(roman)

  # build widget .ascfontsel.mb_frm.ok_btn
  button .ascfontsel.mb_frm.ok_btn \
    -command ascFont_exit \
    -text {OK}

  # build widget .ascfontsel.mb_frm.cancel_btn
  button .ascfontsel.mb_frm.cancel_btn \
    -command ascFont_cancel \
    -text {Cancel}

  # pack widget .ascfontsel.mb_frm
  pack append .ascfontsel.mb_frm \
    .ascfontsel.mb_frm.font_btn {left frame center fillx} \
    .ascfontsel.mb_frm.style_btn {left frame center fillx} \
    .ascfontsel.mb_frm.ok_btn {right frame center fillx} \
    .ascfontsel.mb_frm.cancel_btn {right frame center fillx}

  # build widget .ascfontsel.frame
  frame .ascfontsel.frame

  # build widget .ascfontsel.frame.label4
  label .ascfontsel.frame.label4 \
    -text {Font selected:}

  # build widget .ascfontsel.frame.entry5
  entry .ascfontsel.frame.entry5 \
    -exportselection 0

  # pack widget .ascfontsel.frame
  pack append .ascfontsel.frame \
    .ascfontsel.frame.label4 {left frame center} \
    .ascfontsel.frame.entry5 {top frame center expand fill}

  # build widget .ascfontsel.scale9
  scale .ascfontsel.scale9 \
    -label {Number of points} \
    -orient {horizontal} \
    -from 4 \
    -to 48 \
    -tickinterval 4 \
    -bigincrement 4 \
    -variable ascFontVect(size) \
    -showvalue {0}

  # build widget .ascfontsel.test_frm
  frame .ascfontsel.test_frm

  # build widget .ascfontsel.test_frm.scrollbar1
  scrollbar .ascfontsel.test_frm.scrollbar1 \
    -command {.ascfontsel.test_frm.text2 yview}

  # build widget .ascfontsel.test_frm.text2
  text .ascfontsel.test_frm.text2 \
    -exportselection {0} \
    -height 5 \
    -wrap {word} \
    -yscrollcommand {.ascfontsel.test_frm.scrollbar1 set}

  # pack widget .ascfontsel.test_frm
  pack append .ascfontsel.test_frm \
    .ascfontsel.test_frm.scrollbar1 {right frame center filly} \
    .ascfontsel.test_frm.text2 {top frame center expand fill}


  # build widget .ascfontsel.samp_frm
  frame .ascfontsel.samp_frm

  # build widget .ascfontsel.samp_frm.scrollbar1
  scrollbar .ascfontsel.samp_frm.scrollbar1 \
    -command {.ascfontsel.samp_frm.list2 yview}

  # build widget .ascfontsel.samp_frm.list2
  text .ascfontsel.samp_frm.list2 \
    -exportselection {0} \
    -height 4 \
    -wrap none \
    -yscrollcommand {.ascfontsel.samp_frm.scrollbar1 set}

  # pack widget .ascfontsel.samp_frm
  pack append .ascfontsel.samp_frm \
    .ascfontsel.samp_frm.scrollbar1 {right frame center filly} \
    .ascfontsel.samp_frm.list2 {top frame center expand fill}

  # pack widget .ascfontsel
  pack append .ascfontsel \
    .ascfontsel.mb_frm {top frame center fillx} \
    .ascfontsel.test_frm {top frame n fillx} \
    .ascfontsel.samp_frm {top frame n expand fill} \
    .ascfontsel.scale9 {top frame center fillx} \
    .ascfontsel.frame {top frame center fill} \

  .ascfontsel.frame.entry5 insert end {courier}
  set ascFontVect(sample) {This is a sample of text in @@@, or the closest match. You can edit this text. MODEL foo() 1234567890_= !@#$%^&*()-+ <>,.?/{}[]~\|`'" qwertyuiop asdfghjkl zxcvbnm QWERTYUIOP ASDFGHJKL ZXCVBNM }
  ascFont_fillsamples
  ascFont_configure 0 0 0
}

proc DestroyWindow.ascfontsel {} {# xf ignore me 7
    catch "destroy .ascfontsel"
    update
}


# User defined procedures


# Internal procedures

# eof
#
} ;# endif ascfontsel.tcl include

###########################################################################
#ifndef cmu-bindings
if {"[info proc set_cmuBindings]" == ""} {
proc set_cmuBindings {} {
  global tcl_platform tk_strictMotif
# we don't understand why scanning is supposed to work only with
# b1 down. haven't been able to find any unwanted side effects of this
# baa 6/12/97, tk80b1-no patches
  bind Menubutton <Motion> {
    global tk_strictMotif
    if {$tk_strictMotif} {
      tkMbMotion %W up %X %Y
    } else {
      tkMbMotion %W down %X %Y
    }
  }
# puts "Adding cmu Entry and Text bindings"
  #
  # Entries:
  #
  # define Ctrl-u for unix folks.
  bind Entry <Control-Key-u> {
    if !$tk_strictMotif {
      %W delete 0 end
    }
  }
  #
  #define delete and backspace to be backspace.
  bind Entry <Key-Delete> {
    if !$tk_strictMotif {
      tkEntryBackspace %W
    }
  }
 if {$tcl_platform(platform)=="unix" && !$tk_strictMotif} {
    # the standard tcl text bindings. Swap them.
    # bind Text <Delete> {
    #    if {[%W tag nextrange sel 1.0 end] != ""} {
    #        %W delete sel.first sel.last
    #    } else {
    #        %W delete insert
    #        %W see insert
    #    }
    #} 
    #bind Text <BackSpace> {
    #    if {[%W tag nextrange sel 1.0 end] != ""} {
    #        %W delete sel.first sel.last
    #    } elseif [%W compare insert != 1.0] {
    #        %W delete insert-1c
    #        %W see insert
    #    }
    #}
    bind Text <BackSpace> {
        if {[%W tag nextrange sel 1.0 end] != ""} {
            %W delete sel.first sel.last
        } else {
            %W delete insert
            %W see insert
        }
    }
    bind Text <Delete> {
        if {[%W tag nextrange sel 1.0 end] != ""} {
            %W delete sel.first sel.last
        } elseif [%W compare insert != 1.0] {
            %W delete insert-1c
            %W see insert
        }
    }
  }
}
} ;# endif cmubindings


###########################################################################
# this part must be absolutely last
#if {[catch {}}
            set_cmuBindings
            if {$argv != ""} {
              append a tkxg " " $argv
              puts $a
              set i [eval $a]
              global __tkxg_current
              set __tkxg_current $i
              Tkxg_InitMarkers
              Tkxg_PlotCurrent
              Tkxg_finish
#             Tkxg_dump $i
            }
           #} ]} {
  #exit
#}

