#ifndef _TKXG_H_SEEN_
#define _TKXG_H_SEEN_

/* debug boolean for tkxgraph */
#define TDEBUG 0

/* here we define some command names that tkxg.tcl must supply */

/* proc $SEGCON {color width {stipple ""}} set global vars for line */
#define TKXG_SEGCON "Tkxg_cseg"

/* proc $SEG {x1 y1 x2 y2} draw line using global color,width,stipple */
#define TKXG_SEG "Tkxg_seg"

/* proc $DOT {x y style type color} */
#define TKXG_DOT "Tkxg_dot"

/* proc $TEXT {val x y anchor font} */
#define TKXG_TEXT "Tkxg_text"

/*
 * does the startup sequence.
 */
extern int Tkxg_Init _ANSI_ARGS_((Tcl_Interp *));


/*
 * defines a new xgraph and returns.
 * tkxgraph canvasname filename 
 * Bugs: filename should be replaceable with -data {datalist}
 * graph is defined with the defaults plus whatever
 * changes to the defaults are defined in the input file.
 */
extern int Tkxg_Create
_ANSI_ARGS_((ClientData cdata, Tcl_Interp *interp, int argc, char *argv[]));


/*
 * Parses new values for options, redraws, or destroys the graph.
 * The clientdata for this must be registered by Create
 * in widgetish style.
 */
extern int Tkxg_Update
_ANSI_ARGS_((ClientData cdata, Tcl_Interp *interp, int argc, char *argv[]));

#endif
